global function NukeMap_Init

struct
{
    entity iniquity
    bool explode = false
    bool enable_this = true
    bool csloadouts = false
    bool kaberMontage = false
} file

void function NukeMap_Init()
{
    if ( !file.enable_this )
        return

    // AddCallback_OnClientConnected( OnPlayerConnected )
    AddCallback_OnPlayerRespawned( OnPlayerConnected )
    AddCallback_OnPlayerGetsNewPilotLoadout( OnPlayerLoadoutSwaped )
    AddClientCommandCallback( "PlzMenu", catSaidChooseEvent )
    AddClientCommandCallback( "inquity_dialogue_nuke", IniquitySaidNuke )
    AddClientCommandCallback( "inquity_dialogue_loadouts", IniquitySaidLoadouts )
    AddClientCommandCallback( "inquity_dialogue_kraber_montage", IniquitySaidKraberMontage )
    AddClientCommandCallback( "inquity_dialogue_disable", IniquitySaidDisableAll )
    AddClientCommandCallback( "selfiniq", IniquityOverride )
}

bool function catSaidChooseEvent( entity player, array<string> args )
{
    if ( IsValid( file.iniquity ) && IsValid( player ) && ( player.GetPlayerName() == "cat_or_not" || file.iniquity ) )
        ServerToClientStringCommand( file.iniquity, "OpenConfirmation" )
    
    return true
}

bool function IniquityOverride( entity player, array<string> args )
{
    file.iniquity = player

    return true
}

void function OnPlayerConnected( entity player )
{
    if ( player.GetPlayerName() == "SarahBriggsSimp" )
        file.iniquity = player
    
    if ( file.csloadouts )
        GiveCoolLoadout( player )

    if ( file.kaberMontage )
        GiveKraberMontage( player )
}

void function OnPlayerLoadoutSwaped( entity player, PilotLoadoutDef newTitanLoadout )
{
    if ( file.csloadouts )
        GiveCoolLoadout( player )
    
    if ( file.kaberMontage )
        GiveKraberMontage( player )
}

void function GiveCoolLoadout( entity player )
{
    if ( !IsValid( player ) || !IsPilot( player ) || !IsAlive( player ) )
        return
    
    TakeAllWeapons( player )

    player.GiveWeapon( "mp_weapon_lstar", ["tactical_cdr_on_kill", "extended_ammo", "pas_fast_reload", "pro_screen" ] )

    player.GiveWeapon( "mp_weapon_shotgun_pistol", [ "pas_fast_reload", "extended_ammo", "pro_screen" ] )

    player.GiveWeapon( "mp_weapon_defender", [ "slammer", "pro_screen", "extended_ammo" ] )
    
    player.GiveOffhandWeapon( "mp_ability_holopilot", OFFHAND_SPECIAL, [] )

    player.GiveOffhandWeapon( "mp_weapon_satchel", OFFHAND_ORDNANCE, [] )

    player.GiveOffhandWeapon( "melee_pilot_arena", OFFHAND_MELEE, [] )

    player.SetActiveWeaponByName( "mp_weapon_hemlok_smg" )
}

void function GiveKraberMontage( entity player )
{
    if ( !IsValid( player ) || !IsPilot( player ) || !IsAlive( player ) )
        return
    
    TakeAllWeapons( player )

    player.GiveWeapon( "mp_weapon_sniper", ["tactical_cdr_on_kill", "extended_ammo", "pas_fast_reload", "pro_screen", "pas_fast_ads" ] )

    player.GiveWeapon( "mp_weapon_defender", [ "slammer", "pro_screen", "extended_ammo" ] )

    player.GiveWeapon( "mp_weapon_defender", [ "slammer", "pro_screen", "extended_ammo" ] )
    
    player.GiveOffhandWeapon( "mp_ability_grapple", OFFHAND_SPECIAL, [] )

    player.GiveOffhandWeapon( "mp_weapon_satchel", OFFHAND_ORDNANCE, [] )

    player.SetActiveWeaponByName( "mp_weapon_sniper" )
}

bool function IniquitySaidNuke( entity player, array<string> args )
{
    if ( IsValid( file.iniquity ) && file.iniquity == player && !file.explode && GAMETYPE == "tdm" ) // tdm because thats the only gamemode with stable npc titans
        Init_explode()
    else if( IsValid( file.iniquity ) && file.iniquity == player && GAMETYPE == "tdm" )
        file.explode = false
    
    return true
}

bool function IniquitySaidLoadouts( entity player, array<string> args )
{
    if ( IsValid( file.iniquity ) && file.iniquity == player && !file.csloadouts )
    {
        file.csloadouts = true
        
        foreach( player in GetPlayerArray() )
            GiveCoolLoadout( player )
    }
    else if( IsValid( file.iniquity ) && file.iniquity == player )
        file.csloadouts = false
    
    return true
}

bool function IniquitySaidKraberMontage( entity player, array<string> args )
{

    if ( IsValid( file.iniquity ) && file.iniquity == player && !file.kaberMontage )
    {
        file.kaberMontage = true
        Chat_ServerBroadcast( format( "Iniquity fires away in this kraber G%d montage!", file.iniquity.GetGen() ) )

        foreach( player in GetPlayerArray() )
            GiveKraberMontage( player )
    }
    else if( IsValid( file.iniquity ) && file.iniquity == player )
        file.kaberMontage = false
    

    return true
}

bool function IniquitySaidDisableAll( entity player, array<string> args )
{
    if ( IsValid( file.iniquity ) && file.iniquity == player )
    {
        file.csloadouts = false
        file.kaberMontage = false
        file.explode = false
    }

    return true
}

void function Init_explode()
{
    if ( file.explode )
        return
    
    file.explode = true

    thread MapDestructionThreaded()
}

void function MapDestructionThreaded()
{
    vector SelectedPlace
    array<entity> titanSpawnPoints

    while( file.explode )
    {
        SelectedPlace = <0,0,0>
        titanSpawnPoints = SpawnPoints_GetTitan()
        foreach( entity player in GetPlayerArray() )
        {
            entity spawnpoint

            if ( IsValid( player ) )
                spawnpoint = GetClosest( titanSpawnPoints, player.GetOrigin(), 500 )
            
            if ( IsValid( spawnpoint ) )
            {
                SelectedPlace = spawnpoint.GetOrigin()
            }
        }

        // Chat_ServerBroadcast( "postion is : " + SelectedPlace )

        if ( SelectedPlace != <0,0,0> )
        {
            entity nukeTitan = CreateNPCTitan( "npc_titan_ogre", TEAM_MILITIA, SelectedPlace, <0,0,0>, [] ) // why do I need []
            SetSpawnOption_NPCTitan( nukeTitan, TITAN_HENCH )
            SetSpawnOption_AISettings( nukeTitan, "npc_titan_ogre_minigun_nuke" )
            SetSpawnOption_Warpfall( nukeTitan )
            DispatchSpawn( nukeTitan )

            NPC_SetNuclearPayload( nukeTitan )
            SetTeam( nukeTitan, 10 )

            thread KillOnLanding( nukeTitan )
        }

        wait 2
    }

    print( "airstrike ended" )
}

void function KillOnLanding( entity titan )
{
    while( IsValid( titan ) && !titan.IsOnGround() )
        WaitFrame()
    
    if ( IsValid( titan ) )
		thread AutoTitan_SelfDestruct( titan )
}